//+------------------------------------------------------------------+
//|                                                 SuperMaster.mq4 |
//|                                           Copyright 2013, Sergey |
//|                                                omelnik70@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Sergey"
#property link      "omelnik70@mail.ru"
#include <stderror.mqh>

extern string FridayTimeNot = "21:59";
extern int Parol=4857;
extern int magic = 111;
extern double a = 1;
extern double step = 0.002;
extern double bUSD = 1;
extern double minLot = 0.01;

//extern double stopLoss = 50.5;
//extern double takeProfit = 50.5;
extern int slippage = 10;
extern double plusPip = 1;
extern double max = 0.2;
extern datetime closeTime = D'2015.01.01 00:00';
extern bool SwapMetka = true;
extern bool noDump=true;
//extern int spread = 3;


double min_lot, max_lot;
int pip,lotdigits;
bool exit=false;
bool exit2=false;
bool last = false;
int ret,ret2;

datetime cycleStart=0;
datetime lastMin=0;
int file1;
bool init;

double historyLot[];
double historyProfit[];
int size;
int flog;
double mySpread;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   int x,y;
   
   init = false;
//----
   if(Digits==5 || Digits==3)
      pip=10;
   else
      pip=1;
   min_lot = MarketInfo(Symbol(), MODE_MINLOT);
   max_lot = MarketInfo(Symbol(), MODE_MAXLOT);
   while(true)
   {
      x=min_lot*100000;
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=5;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=4;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=3;
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=2;      
         break;
      }   
      y=(x-x/10*10);
      x/=10;
      if(y!=0)
      {
         lotdigits=1;   
         break;
      }
      break;   
   }   
    file1 = FileOpen("date.log", FILE_BIN|FILE_READ|FILE_WRITE);
    if(file1!=-1)
    {
      GetLastError();
      FileSeek(file1,0,SEEK_SET);
      cycleStart = FileReadInteger(file1);
      ret = GetLastError();
      lastMin = FileReadInteger(file1);
      ret2 = GetLastError();
      if((ret2 == 0 && ret == 0) || ret == ERR_END_OF_FILE || ret2 == ERR_END_OF_FILE)
         init = true;
    }
  //  Comment(file1+" "+ret2+" "+ret+" "+init);
//----
   if(ObjectFind("profit")==-1)
   {
      ObjectCreate("profit",OBJ_LABEL,0,10,10);
      ObjectSet("profit",OBJPROP_XDISTANCE,20);
      ObjectSet("profit",OBJPROP_YDISTANCE,20);
      ObjectSet("profit",OBJPROP_COLOR,Lime);
   }
   if(ObjectFind("start")==-1)
   {
      ObjectCreate("start",OBJ_LABEL,0,10,10);
      ObjectSet("start",OBJPROP_XDISTANCE,20);
      ObjectSet("start",OBJPROP_YDISTANCE,40);
      ObjectSet("start",OBJPROP_COLOR,Lime);
   }
   if(ObjectFind("end")==-1)
   {
      ObjectCreate("end",OBJ_LABEL,0,10,10);
      ObjectSet("end",OBJPROP_XDISTANCE,20);
      ObjectSet("end",OBJPROP_YDISTANCE,60);
      ObjectSet("end",OBJPROP_COLOR,Lime);
   }
   if(ObjectFind("profitSar")==-1)
   {
      ObjectCreate("profitSar",OBJ_LABEL,0,10,10);
      ObjectSet("profitSar",OBJPROP_XDISTANCE,20);
      ObjectSet("profitSar",OBJPROP_YDISTANCE,80);
      ObjectSet("profitSar",OBJPROP_COLOR,Lime);
   }
   
   flog = FileOpen("log.log",FILE_BIN|FILE_WRITE);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("profit");
   ObjectDelete("start");
   ObjectDelete("end");
   ObjectDelete("profitSar");
   FileClose(file1);
   FileClose(flog);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(Check()==false)                
   return; 
   int ticket;
   int obuy,opbuy,osell,opsell,total;
   double lot, open,val;
   double profit, y;
   int i,k;
   string name;
   double profitSar=0;
   //double sl,tp;
   
   
   if(!init)
      return;
   if(TimeCurrent() > closeTime)
   {
      close_all(true,true,true,true,false);
      return;
      
   }
//----

   if(exit2)
   {
      if(!close_all(true,true,true,true,true))
            return;
      
      dump("--      --"); 
      exit2=false;   
   }
   double sar = iSAR(NULL,0,step,max,0);
   double sar2 = iSAR(NULL,0,step,max,1);
   double stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)+1;
   double mySpread = MarketInfo(Symbol(),MODE_SPREAD);
if(!cd(sar2,0.0,Digits) && !cd(sar,0.0,Digits))
{  
   total_open(obuy,opbuy,osell,opsell);
   total = obuy+opbuy+osell+opsell;
      
      if(total == 0)
      {
         cycleStart = TimeCurrent();
         lastMin=0;
         last=false; 
         lot = minLot*a;
         ticket=-1;
         if(sar > High[1])
         {
            open = sar+plusPip*Point*pip+mySpread*Point;
            if(open - Ask <  stopLevel*Point)
               open = Ask + stopLevel*Point;
            ticket = OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Blue);   
            if(ticket!=-1)
            {
               dump("--    -- "+ticket);
            }
         }   
         else if(sar < Low[1])
         {
            open = sar-plusPip*Point*pip;
            if(Bid - open <  stopLevel*Point)
              open = Bid - stopLevel*Point;
          //  sl = NormalizeDouble(open+stopLoss*Point*pip,Digits);   
          //  tp = NormalizeDouble(open-takeProfit*Point*pip,Digits);
            ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Red);   
            if(ticket!=-1)
            {
               dump("--    -- "+ticket);
            }
         }   
         if(ticket!=-1)
         {  
            
         }    
      }
      else
      {
         
         i = OrdersHistoryTotal();
         ArrayResize(historyLot, i);
         ArrayResize(historyProfit, i);
         size=0;
         profit = 0;
         for(;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
            {
               if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
               {
                  if(OrderOpenTime()>=cycleStart)
                  {
                     if(OrderType() == OP_SELL || OrderType() == OP_BUY)
                     {
                        historyLot[size] = OrderLots();     
                        historyProfit[size] = OrderProfit()+OrderSwap()+OrderCommission();
                        profit+=historyProfit[size];
                        size++;
                     }
                  }
               }
            }
         }      
         //---
         
         //profit = 0;
         datetime lastTime2 = 0;
       //  double lastVal;
         int lastType=-1;
         int lastTicket=-1;
         lot = 0.0;
         int totalOpen=0;
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS))
            {
               if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
               {  
                  if(OrderOpenTime()<cycleStart)
                     continue;
                  if(OrderOpenTime() > lastTime2)
                  {
                     lastType = OrderType();
                     lastTicket = OrderTicket();
                     lastTime2 = OrderOpenTime();
                  }   
                  if(OrderType()==OP_BUY)
                  {
                     totalOpen++;
                     /*
                     for(k=0;k<size;k++)
                     {
                        if(cd(OrderLots(),historyLot[k],lotdigits))
                        {
                           //profit += historyProfit[k];
                        }
                     }*/
                     lot -= OrderLots();
                     profit += OrderProfit()+OrderSwap()+OrderCommission();    
                  }   
                  else if(OrderType()==OP_SELL)
                  {
                     totalOpen++;
                     /*
                     for(k=0;k<size;k++)
                     {
                        if(cd(OrderLots(),historyLot[k],lotdigits))
                        {
                          // profit += historyProfit[k];
                        }
                     }*/
                     lot += OrderLots();
                     profit += OrderProfit()+OrderSwap()+OrderCommission();
                  }   
               }
            }
         }
         
         if(lastType == OP_SELLSTOP || lastType == OP_BUYSTOP)
         {
            if(OrderSelect(lastTicket,SELECT_BY_TICKET))    
            {
               if(lastType == OP_SELLSTOP || lastType == OP_BUYSTOP)
               {
                  if(lastType == OP_SELLSTOP)
                  {
                     double priceBuy=OrderOpenPrice();
                     double priceSell=priceBuy+mySpread*Point;
                  }
                  else if(lastType == OP_BUYSTOP)
                  { 
                     priceSell=OrderOpenPrice();
                     priceBuy=priceSell-mySpread*Point;
                 
                  }
                  if(cd(OrderLots(),minLot*a,lotdigits))
                  {
                     dump("    "+OrderOpenPrice()+" ticket = "+lastTicket);
                    // Comment("ssssss");
                     //dump("      ");
                     for(i=OrdersTotal()-1;i>=0;i--)
                     {
                        if(OrderSelect(i,SELECT_BY_POS))
                        {
                           if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
                           {  
                              if(OrderType()==OP_BUY)
                              {
                                 if(priceBuy-Bid > stopLevel*Point && (OrderTakeProfit()!=NormalizeDouble(priceBuy,Digits)||OrderStopLoss()!=0))
                                    OrderModify(OrderTicket(),OrderOpenPrice(),0,NormalizeDouble(priceBuy,Digits),0);
                                 if(Bid-priceBuy > stopLevel*Point && (OrderStopLoss()!=NormalizeDouble(priceBuy,Digits)||OrderTakeProfit()!=0))
                                    OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(priceBuy,Digits),0,0);   
                              }
                              else if(OrderType()==OP_SELL)
                              {
                                 if(priceSell-Ask > stopLevel*Point && (OrderStopLoss()!=NormalizeDouble(priceSell,Digits)||OrderTakeProfit()!=0))
                                    OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(priceSell,Digits),0,0);
                                 if(Bid-priceSell > stopLevel*Point && (OrderTakeProfit()!=NormalizeDouble(priceSell,Digits)||OrderStopLoss()!=0))
                                    OrderModify(OrderTicket(),OrderOpenPrice(),0,NormalizeDouble(priceSell,Digits),0);   
                              }
                           }
                        }
                     }      
                  }
                  else
                  {
                      dump("    0000 "+OrderOpenPrice()+" ticket = "+lastTicket);
                     for(i=OrdersTotal()-1;i>=0;i--)
                     {
                        if(OrderSelect(i,SELECT_BY_POS))
                        {
                           if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
                           {  
                              if(OrderType()==OP_BUY || OrderType()==OP_SELL)
                              {
                                 if(OrderTakeProfit()!=0 || OrderStopLoss()!=0)
                                    OrderModify(OrderTicket(),OrderOpenPrice(),0,0,0);
                              }
                           }
                        }
                     } 
                  }
               }   
            }
         }
         if((lastType == OP_SELL || lastType == OP_BUY) && lastMin == lastTicket)
         {
            if(OrderSelect(lastTicket,SELECT_BY_TICKET))
            {
               //Comment(lastMin+ " "+TimeToStr(OrderOpenTime())); 
               cycleStart=OrderOpenTime();
               if(totalOpen>1)
               {
                  dump("       ticket = "+OrderTicket());
                  exit2=true;
                  return;
               }
               
            }
         }
         
         y = 0 + bUSD;
         
         ticket=-1;
         name = TimeToStr(Time[0]);
         profitSar=0;
         datetime time=TimeCurrent();
         datetime time2 = StrToTime(TimeToStr(time,TIME_DATE)+" "+FridayTimeNot);
         Print(TimeToStr(time)+" "+TimeToStr(time2));
    if(!(TimeDayOfWeek(time)==5 && time>time2))
    {
         if(sar > High[1])
         {
            if(lastType != OP_BUY && lastType != OP_SELLSTOP)
            {
               open = sar+plusPip*Point*pip+mySpread*Point;
               if(open - Ask <  stopLevel*Point)
                  open = Ask + stopLevel*Point;
               profitSar=totalProfitAtPrice(open,MODE_ASK);
               Comment("  = "+ sar+"   = "+open+"  = "+profitSar);
               if(profitSar<y)
               {
                  if(cd(lot,0,lotdigits))
                     lot = NormalizeDouble(a*minLot,lotdigits);
                  else
                     lot = NormalizeDouble(MathAbs(lot)*2+minLot,lotdigits);
               }   
               else
               {
                  lot = NormalizeDouble(minLot*a,lotdigits);   
               }   
               if(lot < max_lot)
               {   
                  if(ObjectCreate(name,OBJ_TEXT,0,Time[0],Ask))
                  {
                     ObjectSetText(name, DoubleToStr(open,Digits),7);
                  }
                  val = StrToDouble(ObjectDescription(name));
                  if(open < val)
                    ObjectSetText(name, DoubleToStr(open,Digits),7); 
                  if(lastType == OP_BUYSTOP)
                  {
                    if(OrderSelect(lastTicket,SELECT_BY_TICKET))
                     {
                        if((!cd(OrderOpenPrice(),open,Digits) && open < OrderOpenPrice()) || !cd(lot,OrderLots(),lotdigits))
                        {
                           if(close_all(false,false,true,true,false))
                           { 
                              ticket = OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Blue);
                              if(ticket!=-1)
                              {
                                 if(cd(lot,minLot*a,lotdigits))
                                    lastMin=ticket;
                                 dump(" o       ticket = "+OrderTicket()+" price ="+open+" lot = "+lot);
                              }   
                           }   
                        }   
                     }
                  }
                  else
                  {
                     if(close_all(false,false,true,true,false))
                     {
                        ticket = OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Blue);   
                        if(ticket!=-1)
                        {
                            if(cd(lot,minLot*a,lotdigits))
                              lastMin=ticket;
                           dump("  ticket ="+OrderTicket()+" price = "+open+" lot = "+lot);
                        }   
                     }   
                  }  
               } 
            }   
            
         }   
         else if(sar < Low[1])
         {
           if(lastType != OP_SELL && lastType != OP_BUYSTOP)
           {
               open = sar-plusPip*Point*pip;
               if(Bid - open <  stopLevel*Point)
                 open = Bid - stopLevel*Point;
                profitSar=totalProfitAtPrice(open,MODE_BID);
                Comment("  = "+ sar+"   = "+open+"  = "+profitSar);
                if(profitSar<y)
                {
                  if(cd(lot,0,lotdigits))
                     lot = NormalizeDouble(a*minLot,lotdigits);
                  else   
                     lot = NormalizeDouble(MathAbs(lot)*2+minLot,lotdigits);
               }   
               else
               {
                  lot = NormalizeDouble(minLot*a,lotdigits);
               }  
               if(lot < max_lot)
               {   
                  if(ObjectCreate(name,OBJ_TEXT,0,Time[0],Ask))
                  {
                     ObjectSetText(name, DoubleToStr(open,Digits),7);
                  }  
                  val = StrToDouble(ObjectDescription(name));
                  if(open > val)
                    ObjectSetText(name, DoubleToStr(open,Digits),7); 
                  if(lastType == OP_SELLSTOP)
                  {
                     if(OrderSelect(lastTicket,SELECT_BY_TICKET))
                     {
                        if((!cd(OrderOpenPrice(),open,Digits) && open > OrderOpenPrice()) || !cd(lot,OrderLots(),lotdigits))
                        {
                           if(close_all(false,false,true,true,false))
                           {
                              ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Red);
                              if(ticket!=-1)
                              {
                                 if(cd(lot,minLot*a,lotdigits))
                                     lastMin=ticket;
                                 dump(" o       ticket = "+ticket+" price = "+open+" lot = "+lot);
                              }   
                           }   
                        }   
                     }   
                  }
                  else
                  {  
                     if(close_all(false,false,true,true,false))
                     {
                        ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(lot,lotdigits),NormalizeDouble(open,Digits),slippage,0,0,"",magic,0,Red);
                        if(ticket!=-1)
                        {
                           if(cd(lot,minLot*a,lotdigits))
                              lastMin=ticket;
                           dump("c  ticket = "+ticket+" price = "+open+" lot = "+lot);
                        }   
                     }   
                  }
               }
           }
         }     
            
      }//else
   }   
             
}
//----
   FileSeek(file1,0,SEEK_SET);
   FileWriteInteger(file1,cycleStart);
   FileWriteInteger(file1,lastMin);
            
   ObjectSetText("end","   = "+TimeToStr(closeTime) ,12);
   ObjectSetText("start","  = "+TimeToStr(cycleStart) ,12);
   ObjectSetText("profit"," = "+DoubleToStr(profit,2) ,12);
   ObjectSetText("profitSar","  = "+DoubleToStr(profitSar,2) ,12);
   return(0);
  }
//+------------------------------------------------------------------+

bool Check()                           
  {                                   
   if (IsDemo()==true)                 
      return(true);                    
   if (AccountCompany()=="SuperBank")  
      return(true);                    
   int Key=AccountNumber()*2+77;  
   if (Parol==Key)                     
      return(true);                    
   Alert("  ");
   return(false);                      
  }  
//+------------------------------------------------------------------+

bool close_all(bool closebuy, bool closesell, bool closepbuy,bool closepsell, bool leaveLast)
{
   int i,ord_type;
   int total,cnt;
   int max_try;
   int lastTicket=-1;
   max_try=0;
   cnt=-1;
  
   if(leaveLast)
   {
      Print("====== LEAVE last =========");
      datetime time=0;
      total = OrdersTotal();
      for (i = total-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
         if(OrderSymbol() == Symbol() && OrderMagicNumber()==magic)
         {
             ord_type=OrderType();
             if(ord_type==OP_SELL || ord_type==OP_BUY)
             {
               if(OrderOpenTime()>time)
               {
                  lastTicket=OrderTicket();
                  //cycleStart = OrderOpenTime();  
                  time=OrderOpenTime();
               }
             }
         }
        }
      }  
   }
   while(cnt!=0 && max_try<10)
   {
      total = OrdersTotal();
      cnt=0;
      for (i = total-1; i>=0; i--)
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if(OrderSymbol() == Symbol() && OrderMagicNumber()==magic)
        {
           if(OrderTicket() == lastTicket)
            continue;
           ord_type=OrderType();
           if (ord_type==OP_BUY && closebuy) 
           {
               OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), slippage*pip,Blue);
               cnt++;
           }
           else if (ord_type==OP_SELL && closesell) 
           {
              OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), slippage*pip,Red);
              cnt++;
           }
           else if((ord_type==OP_BUYSTOP || ord_type==OP_BUYLIMIT) && closepbuy)
           { 
               OrderDelete(OrderTicket(),Aqua);
               cnt++;
           }
           else if((ord_type==OP_SELLSTOP || ord_type==OP_SELLLIMIT) && closepsell)
           { 
               OrderDelete(OrderTicket(),Orchid);
               cnt++;
           }
        }   
      }
      Sleep(500);
      max_try++;
   }
   if(cnt==0)
     return(true);
   else
      return(false);  
}

void total_open(int &bo1,int &bo2, int &so1, int &so2)
{
   int i, total,ord_type;
   total = OrdersTotal();
   bo1=0;bo2=0;so1=0;so2=0;
   for(i=total-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic)
         {
            ord_type=OrderType();
            if(ord_type==OP_BUY)
               bo1++;
            else if(ord_type==OP_BUYSTOP || ord_type==OP_BUYLIMIT)
               bo2++;   
            else if(ord_type==OP_SELL)
               so1++;
            else if(ord_type==OP_SELLSTOP || ord_type==OP_SELLLIMIT)
               so2++;   
         }
      }
   }
}

bool cd(double number1,double number2,int prec)
{
   if(NormalizeDouble(number1-number2,prec)==0)
      return(true);
   else 
      return(false);
}

double totalProfitAtPrice(double price, int mode)
{
   int k;
   int ord_type;
   double profit=0;
   double val;
   
   if(mode==MODE_ASK)
   {
      double priceSell = price;
      double priceBuy = price-mySpread*Point;
      
   }
   else if(mode==MODE_BID)
   {
      priceBuy=price;
      priceSell = price+mySpread*Point;  
   }
  // dump("+++   "+price);
   for(k=0;k<size;k++)
   {
  //   dump(historyLot[k]+" "+historyProfit[k]);
     profit += historyProfit[k];
   }
//   dump("  "+profit);
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS))
      {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            ord_type=OrderType();
            if(ord_type==OP_SELL)
            {
               val=lots2profit(Symbol(),OrderLots(),priceSell,OrderOpenPrice(),MODE_ASK);//sell
             //  dump("  = "+ TimeToStr(OrderOpenTime())+"  = "+OrderTicket()+" "+ OrderLots()+"   "+val+"   = "+priceSell+" "+"   = "+OrderOpenPrice());
               profit+=val;
               /*
               for(k=0;k<size;k++)
               {
                  if(cd(OrderLots(),historyLot[k],lotdigits))
                  {
                     profit += historyProfit[k];
                  }
               }*/
               if(SwapMetka)
                  profit+=OrderSwap()+OrderCommission();
             //  dump(" swapmetka "+ OrderSwap()+"  "+OrderCommission());   
            }   
            else if(ord_type==OP_BUY)   
            {
               val=lots2profit(Symbol(),OrderLots(),priceBuy,OrderOpenPrice(),MODE_BID);//buy
             //  dump("  = "+ TimeToStr(OrderOpenTime())+"  = "+OrderTicket()+" "+ OrderLots()+"   "+val+"   = "+priceBuy+" "+"   = "+OrderOpenPrice());
               profit+=val;
               /*
               for(k=0;k<size;k++)
               {
                  if(cd(OrderLots(),historyLot[k],lotdigits))
                  {
                     profit += historyProfit[k];
                  }
               }*/
               if(SwapMetka)
                  profit+=OrderSwap()+OrderCommission();
              //  dump(" swapmetka "+ OrderSwap()+"  "+OrderCommission());      
            }   
         
         }
      }
   }
  // dump("-----   "+profit);
   return(profit);
}
double lots2profit(string pair, double lots, double price1, double price2, int mode)
{
   bool fail=false;
	double crossPrice, profit; string crossCurrency;
	string baseCurrency = StringSubstr(pair, 0, 3);
	string quoteCurrency = StringSubstr(pair, 3, 3);
	string extra = StringSubstr(pair, 6);
	
	
	if(quoteCurrency == "USD")
	{
	 // dump("1 lots2profit "+lots+" "+price2+" "+price1+" "+MarketInfo(pair,MODE_LOTSIZE));
	  if(mode == MODE_ASK)
	     profit = lots*((price2 - price1) * MarketInfo(pair,MODE_LOTSIZE));
	  else
	     profit = lots*((price1 - price2) * MarketInfo(pair,MODE_LOTSIZE));     
	}	
	else if(baseCurrency == "USD")
	{
//	  dump("2 lots2profit "+lots+" "+price2+" "+price1+" "+MarketInfo(pair,MODE_LOTSIZE));
	   if(mode == MODE_ASK)
		 profit = lots*(-(1 - price2/price1) * MarketInfo(pair,MODE_LOTSIZE));
		else
		 profit = lots*((1 - price2/price1) * MarketInfo(pair,MODE_LOTSIZE)); 
	}	
	else
	{
//	  dump("3 lots2profit "+lots+" "+price2+" "+price1+" "+MarketInfo(pair,MODE_LOTSIZE));
	   //Comment(pair+" "+lots+" "+price1+" "+price2+" "+mode);
		crossCurrency = "USD" + quoteCurrency+extra;   
		if(cd(MarketInfo(crossCurrency, mode),0,8))
		{
		  // Comment("0 = "+crossCurrency);
			crossCurrency = quoteCurrency + "USD"+extra;
			if(cd(MarketInfo(crossCurrency, mode),0,8))
			   fail=true;
			else
			   crossPrice  = 1 /MarketInfo(crossCurrency, mode);
		}
		else
		{
			crossPrice  = MarketInfo(crossCurrency, mode);
      }
      if(fail)
         profit=0;
		else
		{
		    if(mode == MODE_ASK)
		       profit = lots * (price2 - price1) * MarketInfo(pair,MODE_LOTSIZE)/ crossPrice;
		    else
		       profit = lots * (price1 - price2) * MarketInfo(pair,MODE_LOTSIZE)/ crossPrice;
		} 
	}
	return (profit);
}


void dump(string str)
{  
   if(noDump)
      return;
   str = str +" "+TimeToStr(Time[0])+"\r\n";
  FileWriteString(flog,str,StringLen(str));
}